/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreHierarchyNext0DeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreHierarchyNext0De extends TableImpl<VCoreHierarchyNext0DeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of
     * <code>common_dd.v_core_hierarchy_next0_de</code>
     */
    public static final VCoreHierarchyNext0De V_CORE_HIERARCHY_NEXT0_DE = new VCoreHierarchyNext0De();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreHierarchyNext0DeRecord> getRecordType() {
        return VCoreHierarchyNext0DeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.key_element</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_hierarchy_next0_de.key_element_type</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_core_hierarchy_next0_de.key_parent_element</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.dn</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.short_name</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.hier_lang</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.order_nr</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_hierarchy_next0_de.lang_value</code>.
     */
    public final TableField<VCoreHierarchyNext0DeRecord, String> LANG_VALUE = createField(DSL.name("lang_value"), SQLDataType.CLOB, this, "");

    private VCoreHierarchyNext0De(Name alias, Table<VCoreHierarchyNext0DeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreHierarchyNext0De(Name alias, Table<VCoreHierarchyNext0DeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_hierarchy_next0_de" as  WITH RECURSIVE t(key_element, key_element_type, key_parent_element, dn, short_name, hier_lang, order_nr) AS (
                SELECT t_core_element_hierarchy.key_element,
                   t_core_element_hierarchy.key_element_type,
                   t_core_element_hierarchy.key_parent_element,
                   t_core_element_hierarchy.dn,
                   t_core_element_hierarchy.short_name,
                   t_core_element_hierarchy.hier_lang,
                   t_core_element_hierarchy.order_nr
                  FROM common_dd.t_core_element_hierarchy
                 WHERE (t_core_element_hierarchy.dn = 'NEXT.NEXT0'::text)
               UNION ALL
                SELECT h.key_element,
                   h.key_element_type,
                   h.key_parent_element,
                   h.dn,
                   h.short_name,
                   h.hier_lang,
                   h.order_nr
                  FROM (common_dd.t_core_element_hierarchy h
                    JOIN t t_1 ON ((t_1.key_element = h.key_parent_element)))
               )
        SELECT t.key_element,
           t.key_element_type,
           t.key_parent_element,
           t.dn,
           t.short_name,
           t.hier_lang,
           t.order_nr,
           t_core_translation.value AS lang_value
          FROM (t
            LEFT JOIN common_dd.t_core_translation ON ((t_core_translation.fk_trans_key = t.hier_lang)))
         WHERE ((t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_hierarchy_next0_de</code> table
     * reference
     */
    public VCoreHierarchyNext0De(String alias) {
        this(DSL.name(alias), V_CORE_HIERARCHY_NEXT0_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_hierarchy_next0_de</code> table
     * reference
     */
    public VCoreHierarchyNext0De(Name alias) {
        this(alias, V_CORE_HIERARCHY_NEXT0_DE);
    }

    /**
     * Create a <code>common_dd.v_core_hierarchy_next0_de</code> table reference
     */
    public VCoreHierarchyNext0De() {
        this(DSL.name("v_core_hierarchy_next0_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreHierarchyNext0De as(String alias) {
        return new VCoreHierarchyNext0De(DSL.name(alias), this);
    }

    @Override
    public VCoreHierarchyNext0De as(Name alias) {
        return new VCoreHierarchyNext0De(alias, this);
    }

    @Override
    public VCoreHierarchyNext0De as(Table<?> alias) {
        return new VCoreHierarchyNext0De(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreHierarchyNext0De rename(String name) {
        return new VCoreHierarchyNext0De(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreHierarchyNext0De rename(Name name) {
        return new VCoreHierarchyNext0De(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreHierarchyNext0De rename(Table<?> name) {
        return new VCoreHierarchyNext0De(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De where(Condition condition) {
        return new VCoreHierarchyNext0De(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreHierarchyNext0De where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreHierarchyNext0De where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreHierarchyNext0De where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreHierarchyNext0De where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreHierarchyNext0De whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
